// -*- C++ -*-
// $Id: InterInArgsT_Sender_exec.h 92620 2010-11-17 11:11:36Z mhengstmengel $

/**
 * Code generated by the The ACE ORB (TAO) IDL Compiler v1.8.3
 * TAO and the TAO IDL Compiler have been developed by:
 *       Center for Distributed Object Computing
 *       Washington University
 *       St. Louis, MO
 *       USA
 *       http://www.cs.wustl.edu/~schmidt/doc-center.html
 * and
 *       Distributed Object Computing Laboratory
 *       University of California at Irvine
 *       Irvine, CA
 *       USA
 * and
 *       Institute for Software Integrated Systems
 *       Vanderbilt University
 *       Nashville, TN
 *       USA
 *       http://www.isis.vanderbilt.edu/
 *
 * Information about TAO is available at:
 *     http://www.cs.wustl.edu/~schmidt/TAO.html
 **/
#ifndef CIAO_INTERINARGST_SENDER_EXEC_XOE8WS_H_
#define CIAO_INTERINARGST_SENDER_EXEC_XOE8WS_H_

#include /**/ "ace/pre.h"
#include "ace/Task.h"
#include "InterInArgsT_SenderEC.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

#include /**/ "InterInArgsT_Sender_exec_export.h"
#include "tao/LocalObject.h"

namespace CIAO_InterInArgsT_Sender_Impl
{
  typedef ACE_Atomic_Op <TAO_SYNCH_MUTEX, CORBA::UShort > Atomic_UShort;

  /// Common exception handlers
  void HandleException (
        long id,
        long expect_id,
        const char* error_string,
        const char* func);
  /// Worker thread for asynchronous invocations
  class asynch_foo_generator : public virtual ACE_Task_Base
  {
    public:
      asynch_foo_generator (::InterInArgsT::CCM_Sender_Context_ptr context,
                                 Atomic_UShort  &nr_of_received_);

      virtual int svc (void);

    private:
      ::InterInArgsT::CCM_Sender_Context_var context_;
      Atomic_UShort  &nr_of_received_;
  };

  /// Worker thread for synchronous invocations
  class synch_foo_generator : public virtual ACE_Task_Base
  {
    public:
      synch_foo_generator (::InterInArgsT::CCM_Sender_Context_ptr context,
                             Atomic_UShort  &nr_of_received_);

      virtual int svc (void);

    private:
      ::InterInArgsT::CCM_Sender_Context_var context_;
      Atomic_UShort  &nr_of_received_;
  };
  /**
  * Component Executor Implementation Class: Sender_exec_i
  */
  class Sender_exec_i
    : public virtual Sender_Exec,
      public virtual ::CORBA::LocalObject
  {
  public:
    Sender_exec_i (void);
    virtual ~Sender_exec_i (void);

    //@{
    /** Supported operations and attributes. */
    //@}

    //@{
    /** Component attributes and port operations. */
    //@}

    //@{
    /** Operations from Components::SessionComponent. */
    virtual void set_session_context (::Components::SessionContext_ptr ctx);
    virtual void configuration_complete (void);
    virtual void ccm_activate (void);
    virtual void ccm_passivate (void);
    virtual void ccm_remove (void);
    //@}

    //@{
    /** User defined public operations. */
    //@}

  private:
    ::InterInArgsT::CCM_Sender_Context_var ciao_context_;
    asynch_foo_generator* asynch_foo_gen;
    synch_foo_generator* synch_foo_gen;

    //@{
    /** Component attributes. */
    //@}

    //@{
    /** User defined members. */
    Atomic_UShort nr_of_received_;
    //@}

    //@{
    /** User defined private operations. */
    //@}
  };

  extern "C" INTERINARGS_T_SENDER_EXEC_Export ::Components::EnterpriseComponent_ptr
  create_InterInArgsT_Sender_Impl (void);
}

#include /**/ "ace/post.h"

#endif /* ifndef */
